<template>
  <form action="post" @submit.prevent=''>
    <div class="p-8 px-16">
      <!-- start: form header -->
      <h1 class="text-2xl text-center font-semibold mb-2">Register</h1>
      <p class="text-center mb-8">Lengkapi data dibawah dan daftar sekarang</p>
      <!-- end: form header -->

      <!-- start: account info input -->
      <form-input
        class="mb-4"
        :id="'email'"
        :label="'Email'"
        :type="'email'"
        v-model="email"
        :error="errorEmail"
      />
      <form-input
        class="mb-4"
        :id="'password'"
        :label="'Password'"
        :type="'password'"
        v-model="password"
        :passwordToggle="true"
        :error="errorPassword"
      />
      <!-- end: account info input -->

      <!-- start: user info input -->
      <form-input
        class="mb-4"
        :id="'name'"
        :label="'Nama Lengkap'"
        :type="'text'"
        v-model="name"
        :error="errorName"
      />
      <form-input
        class="mb-4"
        :id="'tel'"
        :label="'No. Handphone Penanggungjawab'"
        :type="'tel'"
        v-model="tel"
        :error="errorTel"
      />
      <form-input
        class="mb-4"
        :id="'address'"
        :label="'Alamat Lembaga'"
        :type="'text'"
        v-model="address"
        :error="errorAddress"
      />
      <form-input
        class="mb-4"
        :id="'city'"
        :label="'Kota Alamat Lembaga'"
        :type="'text'"
        v-model="city"
        :error="errorCity"
      />
      <!-- end: user info input -->

      <button
        class="text-semibold bg-data-blue py-2 mb-4 rounded-sm w-full"
        type="submit"
      >
        Daftar
      </button>

      <!-- start: login -->
      <div class="text-center text-ui-400 text-sm">
        Sudah punya akun?
        <nuxt-link to="/login" class="font-semibold text-white">
          Masuk Sekarang
        </nuxt-link>
      </div>
      <!-- end: register -->
    </div>
  </form>
</template>

<script>
import { mapState } from 'vuex';
import FormInput from '~/components/FormInput.vue';

export default {
  layout: 'login',

  components: {
    FormInput,
  },

  data: () => ({
    email: '',
    password: '',
    name: '',
    tel: '',
    address: '',
    city: '',

    errorEmail: '',
    errorPassword: '',
    errorName: '',
    errorTel: '',
    errorAddress: '',
    errorCity: '',
  }),

  computed: {
    ...mapState({
      isLoading: 'register/isLoading',
      serverErrorEmail: 'register/errorEmail',
      serverErrorPassword: 'register/errorPassword',
      serverErrorName: 'register/errorName',
      serverErrorTel: 'register/errorTel',
      serverErrorAddress: 'register/errorAddress',
      serverErrorCity: 'register/errorCity',
    }),
  },

  methods: {
    register: function() {
      this.$store.dispatch(
        'register/register',
        {
          email: this.email,
          password: this.password,
          name: this.name,
          tel: this.tel,
          address: this.address,
          city: this.city,
        },
      );

      this.errorEmail = this.serverErrorEmail;
      this.errorPassword = this.serverErrorPassword;
      this.errorName = this.errorName;
      this.errorTel = this.errorTel;
      this.errorAddress = this.errorAddress;
      this.errorCity = this.errorCity;
    },
  },
};
</script>

<style lang="postcss" scoped>
</style>
